import { AppPage } from "./app.po";
import { ListPage } from "./list.po";
import { CalculatorPage } from "./calculator.po";
import { browser } from "protractor";
import { Navbar } from "./navbar.po";

/**
 * Remous
 */
describe("ngHyd − remous", () => {
  let startPage: AppPage;
  let listPage: ListPage;
  let calcPage: CalculatorPage;
  let navBar: Navbar;

  beforeEach(() => {
    startPage = new AppPage();
    listPage = new ListPage();
    calcPage = new CalculatorPage();
    navBar = new Navbar();
  });

  it("when leaving calculated remous page then coming back to it, logs should not be duplicated", async () => {
    await startPage.navigateTo();

    // 1. create new Remous
    await listPage.clickMenuEntryForCalcType(4);
    await browser.sleep(300);

    // 2. calculate it, there should be 6 messages in the log
    await calcPage.getCalculateButton().click();
    expect(await calcPage.nbLogEntries()).toBe(6);
    await browser.sleep(300);

    // 3. go to home page (simplest example)
    await navBar.clickNewCalculatorButton();
    await browser.sleep(300);

    // 4. go back to Remous
    await navBar.clickCalculatorTab(0);
    await browser.sleep(300);

    // 5. there should still be 6 messages in the log
    expect(await calcPage.nbLogEntries()).toBe(6);
  });
});
